/*
wijit ChatDlg.cpp: function definitions for the chat dialog
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/


#include "stdafx.h"
#include "wijit.h"
#include "ChatDlg.h"
#include "WijitDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog


CChatDlg::CChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatDlg)
	m_AllText = _T("");
	m_NewText = _T("");
	m_To = _T("");
	//}}AFX_DATA_INIT
}


void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
	DDX_Control(pDX, IDC_USER, m_UserList);
	DDX_Text(pDX, IDC_ALLTEXT, m_AllText);
	DDX_Text(pDX, IDC_NEWTEXT, m_NewText);
	DDX_CBString(pDX, IDC_USER, m_To);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_CBN_CLOSEUP(IDC_USER, OnCloseupUser)
	ON_WM_CLOSE()
	ON_WM_CANCELMODE()
	ON_CBN_EDITCHANGE(IDC_USER, OnEditchangeUser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

void CChatDlg::OnCloseupUser() 
{

}

void CChatDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if(_From=="")
	{
		CWijitDlg *HomeDlg=(CWijitDlg*)AfxGetMainWnd();
		CL_STRUCT item;
		_From=m_To;
		item.Name=_From;
		item.Window=(DWORD)this;
		item.Type="chat";
		HomeDlg->_ChatList.push_front(item);
		AddMRU(_From);
	}
	m_UserList.EnableWindow(FALSE);
	CString temp;
	temp=m_AllText;
	m_AllText.Format("<< %s\r\n%s",m_NewText,temp);
	*_session << Message(_From.GetBuffer(_From.GetLength()),m_NewText.GetBuffer(m_NewText.GetLength()),Message::mtChat);
	m_NewText="";
	UpdateData(FALSE);
}

void CChatDlg::OnMessage(const Message &m)
{
	if(_From=="") 
		return;
	if(strcmp(_From.GetBuffer(_From.GetLength()),m.getFrom().c_str())==0)
	{ /* this message is for this window */
		CString temp;
		UpdateData(TRUE);
		temp=m_AllText;
		m_AllText.Format(">> %s\r\n%s",m.getBody().c_str(),temp);
		UpdateData(FALSE);
	}
}

void CChatDlg::OnClose() 
{
	CWijitDlg *HomeDlg=(CWijitDlg*)AfxGetMainWnd();
	CL_STRUCT temp;
	temp.Name=_From;
	temp.Window=(DWORD)this;
	temp.Type="chat";
	HomeDlg->_ChatList.remove(temp);
	CDialog::OnClose();
	delete this;
}

void CChatDlg::OnCancelMode() 
{
	CDialog::OnCancelMode();
}

void CChatDlg::OnEditchangeUser() 
{

}

void CChatDlg::DisplayMRU()
{
	CWijitDlg* HomeDlg = (CWijitDlg*)AfxGetMainWnd();
	m_UserList.ResetContent();
	if( HomeDlg->MRU.m10 != "" ) m_UserList.AddString( HomeDlg->MRU.m10 );
	if( HomeDlg->MRU.m9 != "" ) m_UserList.AddString( HomeDlg->MRU.m9 );
	if( HomeDlg->MRU.m8 != "" ) m_UserList.AddString( HomeDlg->MRU.m8 );
	if( HomeDlg->MRU.m7 != "" ) m_UserList.AddString( HomeDlg->MRU.m7 );
	if( HomeDlg->MRU.m6 != "" ) m_UserList.AddString( HomeDlg->MRU.m6 );
	if( HomeDlg->MRU.m5 != "" ) m_UserList.AddString( HomeDlg->MRU.m5 );
	if( HomeDlg->MRU.m4 != "" ) m_UserList.AddString( HomeDlg->MRU.m4 );
	if( HomeDlg->MRU.m3 != "" ) m_UserList.AddString( HomeDlg->MRU.m3 );
	if( HomeDlg->MRU.m2 != "" ) m_UserList.AddString( HomeDlg->MRU.m2 );
	if( HomeDlg->MRU.m1 != "" ) m_UserList.AddString( HomeDlg->MRU.m1 );
	UpdateData( FALSE );
}

void CChatDlg::AddMRU(CString jid)
{
	CWijitDlg* HomeDlg = (CWijitDlg*)AfxGetMainWnd();
	//make sure the jid isn't in the MRU list...
	if(HomeDlg->MRU.m1==jid) return;
	if(HomeDlg->MRU.m2==jid) return;
	if(HomeDlg->MRU.m3==jid) return;
	if(HomeDlg->MRU.m4==jid) return;
	if(HomeDlg->MRU.m5==jid) return;
	if(HomeDlg->MRU.m6==jid) return;
	if(HomeDlg->MRU.m7==jid) return;
	if(HomeDlg->MRU.m8==jid) return;
	if(HomeDlg->MRU.m9==jid) return;
	if(HomeDlg->MRU.m10==jid) return;
	if(HomeDlg->MRU.m10!="") {
		//the list is filled up...
		//bump 1 off, move items down
		HomeDlg->MRU.m1=HomeDlg->MRU.m2;
		HomeDlg->MRU.m2=HomeDlg->MRU.m3;
		HomeDlg->MRU.m3=HomeDlg->MRU.m4;
		HomeDlg->MRU.m4=HomeDlg->MRU.m5;
		HomeDlg->MRU.m5=HomeDlg->MRU.m6;
		HomeDlg->MRU.m6=HomeDlg->MRU.m7;
		HomeDlg->MRU.m7=HomeDlg->MRU.m8;
		HomeDlg->MRU.m8=HomeDlg->MRU.m9;
		HomeDlg->MRU.m9=HomeDlg->MRU.m10;
		//add the new item to 10
		HomeDlg->MRU.m10=jid;
	}
	else {
		//find the last used item,
		if(HomeDlg->MRU.m9!="") 
			HomeDlg->MRU.m10=jid;
		else if(HomeDlg->MRU.m8!="") 
			HomeDlg->MRU.m9=jid;
		else if(HomeDlg->MRU.m7!="") 
			HomeDlg->MRU.m8=jid;
		else if(HomeDlg->MRU.m6!="") 
			HomeDlg->MRU.m7=jid;
		else if(HomeDlg->MRU.m5!="") 
			HomeDlg->MRU.m6=jid;
		else if(HomeDlg->MRU.m4!="") 
			HomeDlg->MRU.m5=jid;
		else if(HomeDlg->MRU.m3!="") 
			HomeDlg->MRU.m4=jid;
		else if(HomeDlg->MRU.m2!="") 
			HomeDlg->MRU.m3=jid;
		else if(HomeDlg->MRU.m1!="") 
			HomeDlg->MRU.m2=jid;
		else
			HomeDlg->MRU.m1=jid;
	}
	DisplayMRU();
}
