/*
wijit WijitDlg.cpp: function definitions for the main dialog
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/
//

#include "stdafx.h"
#include "wijit.h"
#include "wijitDlg.h"
#include "jabberoo.hh"
#include "utils.h"
#include "propConnection.h"
#include "chatdlg.h"

using namespace jabberoo;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWijitDlg dialog

CWijitDlg::CWijitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWijitDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWijitDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWijitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWijitDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWijitDlg, CDialog)
	//{{AFX_MSG_MAP(CWijitDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_WM_CLOSE()
	ON_WM_CANCELMODE()
	ON_WM_MOUSEMOVE()
	ON_WM_CAPTURECHANGED()
	ON_BN_CLICKED(IDOK, OnCancel)
	ON_COMMAND(IDP_EXIT, OnCancel)
	ON_COMMAND(IDP_CHAT, OnChat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWijitDlg message handlers

BOOL CWijitDlg::OnInitDialog()
{
//	SetWindowPos(NULL,0,0,0,0,0);
	HKEY temp;
	DWORD temp2;

	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	_socket._session=&_session;
	_session.evtTransmitXML.connect(slot(_socket,&WSocket::send));
	_session.evtConnected.connect(slot(&CWijitDlg::OnConnected));
	_session.evtDisconnected.connect(slot(&CWijitDlg::Disconnected));
	_session.evtMessage.connect(slot(&CWijitDlg::OnMessage));
	_session.evtIQ.connect(slot(&CWijitDlg::onIQ));
	_session.evtPresence.connect(slot(&CWijitDlg::OnPresence));
	_session.evtPresenceRequest.connect(slot(&CWijitDlg::OnPresenceRequest));
	_session.evtAuthError.connect(slot(&CWijitDlg::OnAuthError));
	SetIconTray(1,0,"wijit -- Not Connected");
	/* get the registry settings */
	RegCreateKeyEx( HKEY_CURRENT_USER, "Software\\Wijits\\m", 0, 0,0,KEY_READ,NULL, &temp, &temp2 );
	RegCloseKey( temp );
	ReadSettings();
	_ChatList.clear();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWijitDlg::OnPaint() 
{
	ShowWindow(SW_HIDE);
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CWijitDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWijitDlg::OnConnect() 
{
	CPropertySheet sheet("Preferences");
	CPropConnection Page1;
	sheet.AddPage(&Page1);
	if(sheet.DoModal()==IDCANCEL)
		return;
	if(!_socket.IsCreated)
	{
		_socket.Create();
		_socket.IsCreated=true;
	}
	if(_socket.Connect("jabber.org",5222))
	{
		_session.connect(li.ServerName.GetBuffer(li.ServerName.GetLength()),Session::atPlaintextAuth,li.UserName.GetBuffer(li.UserName.GetLength()),li.Resource.GetBuffer(li.Resource.GetLength()),li.Password.GetBuffer(li.Password.GetLength()));
	}
	else
	{
		AfxMessageBox("Not Connected");
	}
	
}

void CWijitDlg::OnClose() 
{
	SetIconTray(0,0,"");
	CDialog::OnClose();
}

void CWijitDlg::OnCancelMode() 
{
	CDialog::OnCancelMode();
}

void CWijitDlg::OnConnected(const Tag &t)
{
	((CWijitDlg*)AfxGetMainWnd())->SetIconTray(2,1,"wijit -- Connected to server");
}

void CWijitDlg::Disconnected()
{
	/* Do nothing */
}

void CWijitDlg::OnMessage(const Message &m)
{
	CHAT_LIST::iterator I;
	CWijitDlg *HomeDlg=(CWijitDlg*)AfxGetMainWnd();
	if(m.getType()==Message::mtError||m.getType()==Message::mtGroupchat||m.getType()==Message::mtHeadline)
		return;
	for(I=HomeDlg->_ChatList.begin();I!=HomeDlg->_ChatList.end();I++)
		if(strcmp(I->Name.GetBuffer(I->Name.GetLength()),m.getFrom().c_str())==0)
			break;
	if(I==HomeDlg->_ChatList.end())
	{ /* create a new chat window */
		CL_STRUCT item;
		CChatDlg *dlg=new CChatDlg;
		dlg->Create(IDD_MESSAGE,GetDesktopWindow());
		dlg->_From=m.getFrom().c_str();
		dlg->m_AllText.Format(">> %s",m.getBody().c_str());
		dlg->m_UserList.AddString(m.getFrom().c_str());
		dlg->m_UserList.SetCurSel(0);
		dlg->m_To=m.getFrom().c_str();
		dlg->m_UserList.EnableWindow(FALSE);
		dlg->DisplayMRU();
		dlg->UpdateData(FALSE);
		HomeDlg->_session.evtMessage.connect(slot(*dlg,CChatDlg::OnMessage));
		item.Name=m.getFrom().c_str();
		item.Window=(DWORD)dlg;
		item.Type="chat";
		HomeDlg->_ChatList.push_front(item);
		dlg->_session=&HomeDlg->_session;
	}
	AfxGetMainWnd()->SetWindowText(m.getBody().c_str());
}

void CWijitDlg::onIQ(const Tag &t)
{
	AfxGetMainWnd()->SetWindowText("incoming IQ");
}

void CWijitDlg::OnPresence(const Presence &p)
{
	CString text;
	text.Format("presence from: %s",p.getFrom().c_str());
	AfxGetMainWnd()->SetWindowText(text);
}

void CWijitDlg::OnPresenceRequest(const Presence &p)
{
	CString text;
	text.Format("presence Request from: %s",p.getFrom().c_str());
	AfxGetMainWnd()->SetWindowText(text);
}

void CWijitDlg::OnAuthError(int eCode, const char *msg)
{
	CString text;
	text.Format("Could not log in: %s",msg);
	AfxGetMainWnd()->SetWindowText(text);
	((CWijitDlg*)AfxGetMainWnd())->Disconnect();
}

void CWijitDlg::SetIconTray(const int Action, const int Image, const CString ToolTip) const
{
	DWORD dwAction;
	/* 
		0 - delete
		1 - add
		2 - change
	*/
	switch( Action ) 
	{
	case 0:
		dwAction = NIM_DELETE;
		break;
	case 1:
		dwAction = 	NIM_ADD;
		break;
	case 2:
		dwAction = NIM_MODIFY;
		break;
	};
	NOTIFYICONDATA nid;
	nid.cbSize = sizeof( NOTIFYICONDATA );
	nid.hWnd = this->GetSafeHwnd();
	nid.uID = 1;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	if( ToolTip != "" ) strncpy( nid.szTip, ToolTip + '\0', ToolTip.GetLength() + 1);
	nid.uCallbackMessage = WM_MOUSEMOVE;
	if( Image == 0 ) 
		nid.hIcon = this->GetIcon( FALSE );
	else if( Image == 1 ) 
		nid.hIcon = AfxGetApp()->LoadIcon( IDI_CONNECTED );
	Shell_NotifyIcon( dwAction, &nid );
}

void CWijitDlg::OnCancel() 
{
	OnClose();
	CDialog::OnCancel();
}

void CWijitDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	UINT *wParam=(UINT*)((void*)&point);
	if(*wParam==WM_RBUTTONDOWN) 
	{
		if(nFlags==1) 
		{
			CMenu v;
			POINT *q = new POINT;
			GetCursorPos(q);
			v.LoadMenu(IDR_POPUP);
			CMenu *temp = v.GetSubMenu(0);
			SetForegroundWindow();
			temp->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,q->x,q->y,this);
			PostMessage(WM_NULL,0,0);
			delete q;
		}
	}
	if(*wParam==WM_LBUTTONUP) 
	{
		if(nFlags==1) 
		{
			//do nothing OnRestore();
		}
	}
	if(*wParam==WM_LBUTTONDBLCLK) 
	{
		if(nFlags==1) 
		{
			switch(_session.getConnState())
			{
			case Session::csNotConnected:
				OnConnect();
				break;
			case Session::csCreateUser:
			case Session::csAuthReq:
			case Session::csAwaitingAuth:
			case Session::csConnected:
				Disconnect();
				break;
			}
		}
	}
	CDialog::OnMouseMove(nFlags, point);
}

void CWijitDlg::OnCaptureChanged(CWnd *pWnd) 
{
	CDialog::OnCaptureChanged(pWnd);
}

void CWijitDlg::Disconnect()
{
	if(_session.getConnState() != Session::csNotConnected)
	{
		_session.disconnect();
		_socket.Close();
		_socket.IsCreated=false;
		SetIconTray(2,0,"wijit -- Disconnected");
	}
}

void CWijitDlg::ReadSettings()
{
		HKEY key;
		RegOpenKey( HKEY_CURRENT_USER, "Software\\Wijits\\m", &key );
		if( !LoadRegValue( key, "Server", li.ServerName ) ) return;
		if( !LoadRegValue( key, "UserName", li.UserName ) ) return;
		if( !LoadRegValue( key, "PassWord", li.Password ) ) return;
		if( !LoadRegValue( key, "Resource", li.Resource ) ) return;
		if( !LoadRegValue( key, "MRU1", MRU.m1 ) ) return;
		if( MRU.m1 == " " ) MRU.m1 = "";
		if( !LoadRegValue( key, "MRU2", MRU.m2 ) ) return;
		if( MRU.m2 == " " ) MRU.m2 = "";
		if( !LoadRegValue( key, "MRU3", MRU.m3 ) ) return;
		if( MRU.m3 == " " ) MRU.m3 = "";
		if( !LoadRegValue( key, "MRU4", MRU.m4 ) ) return;
		if( MRU.m4 == " " ) MRU.m4 = "";
		if( !LoadRegValue( key, "MRU5", MRU.m5 ) ) return;
		if( MRU.m5 == " " ) MRU.m5 = "";
		if( !LoadRegValue( key, "MRU6", MRU.m6 ) ) return;
		if( MRU.m6 == " " ) MRU.m6 = "";
		if( !LoadRegValue( key, "MRU7", MRU.m7 ) ) return;
		if( MRU.m7 == " " ) MRU.m7 = "";
		if( !LoadRegValue( key, "MRU8", MRU.m8 ) ) return;
		if( MRU.m8 == " " ) MRU.m8 = "";
		if( !LoadRegValue( key, "MRU9", MRU.m9 ) ) return;
		if( MRU.m9 == " " ) MRU.m9 = "";
		if( !LoadRegValue( key, "MRU10", MRU.m10 ) ) return;
		if( MRU.m10 == " " ) MRU.m10 = "";
		return;
}

void CWijitDlg::WriteSettings()
{
		HKEY key;
		RegOpenKey( HKEY_CURRENT_USER, "Software\\Wijits\\m", &key );
		if( !SaveRegValue( key, "Server", li.ServerName) ) return;
		if( !SaveRegValue( key, "UserName", li.UserName ) ) return;
		if( !SaveRegValue( key, "PassWord", li.Password ) ) return;
		if( !SaveRegValue( key, "Resource", li.Resource ) ) return;
		if( !SaveRegValue( key, "MRU1", MRU.m1 ) ) return;
		if( !SaveRegValue( key, "MRU2", MRU.m2 ) ) return;
		if( !SaveRegValue( key, "MRU3", MRU.m3 ) ) return;
		if( !SaveRegValue( key, "MRU4", MRU.m4 ) ) return;
		if( !SaveRegValue( key, "MRU5", MRU.m5 ) ) return;
		if( !SaveRegValue( key, "MRU6", MRU.m6 ) ) return;
		if( !SaveRegValue( key, "MRU7", MRU.m7 ) ) return;
		if( !SaveRegValue( key, "MRU8", MRU.m8 ) ) return;
		if( !SaveRegValue( key, "MRU9", MRU.m9 ) ) return;
		if( !SaveRegValue( key, "MRU10", MRU.m10 ) ) return;
		return;
}

void CWijitDlg::OnChat() 
{
	CChatDlg *dlg=new CChatDlg;
	dlg->Create(IDD_MESSAGE,GetDesktopWindow());
	dlg->_From="";
	dlg->DisplayMRU();
	_session.evtMessage.connect(slot(*dlg,CChatDlg::OnMessage));
	dlg->_session=&_session;
}
